/**
 * @file
 */

(function ($) {
    'use strict';
    Drupal.behaviors.handsontablecsv = {
        attach: function (context, settings) {

            var renderedTables = $(document).find('.rendered-table.format-csv');

            renderedTables.each(function () {

                var textarea = $(this).parent().find('input[type="hidden"]');
                if ((($(textarea).val()).length > 0) && (($(this).html()) == '')) {
                    var data = Papa.parse($(textarea).val()).data;
                    var header = data[0];
                    var table = new Handsontable(this, {
                        data: data,
                        stretchH: 'all',
                        contextMenu: {
                          items: {
                            'row_above': {
                              "name": Drupal.t('Insert row above'),
                            },
                            'row_below': {
                              "name": Drupal.t('Insert row below'),
                            },
                            'hsep1': "---------",
                            'col_left': {
                              "name": Drupal.t('Insert column on the left'),
                            },
                            'col_right': {
                              "name": Drupal.t('Insert column on the right'),
                            },
                            'hsep2': '---------',
                            'remove_row': {
                              "name": Drupal.t('Remove row'),
                            },
                            'remove_col': {
                              "name": Drupal.t('Remove column'),
                            },
                            'hsep3': '---------',
                            'undo': {
                              "name": Drupal.t('Undo'),
                            },
                            'redo': {
                              "name": Drupal.t('Redo'),
                            },
                            'hsep4': "---------",
                            'cut': {
                              "name": Drupal.t('Cut'),
                            },
                            'copy': {
                              "name": Drupal.t('Copy'),
                            },
                          }
                        },
                    });
                    table.updateSettings({
                        afterChange: function (e) {
                            $(textarea).val(Papa.unparse(table.getData()));
                        },
                        afterCreateRow: function (index,amount) {
                            $(textarea).val(Papa.unparse(table.getData()));
                        },
                        afterRemoveCol: function (index,amount) {
                            $(textarea).val(Papa.unparse(table.getData()));
                        },
                        afterRowMove: function (index,amount) {
                            $(textarea).val(Papa.unparse(table.getData()));
                        },
                        afterRemoveRow: function (index,amount) {
                            $(textarea).val(Papa.unparse(table.getData()));
                        },
                        afterCreateCol: function (index,amount) {
                            $(textarea).val(Papa.unparse(table.getData()));
                        }
                    });
                }

            });

        }
    };
}(jQuery));
